/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Netscape Public
 * License Version 1.1 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy of
 * the License at http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS
 * IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
 * implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code is mozilla.org code.
 *
 * The Initial Developer of the Original Code is Netscape
 * Communications Corporation.  Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation. All
 * Rights Reserved.
 *
 * Contributor(s):
 *   Jerry Liu <jerry@purplebunny.com>
 */

var version = "0.5.2";
var mRank = null;
var mWin = null;
var mState = 1;
var mLastURL = null;
var mLastPR = 0;
var mNewWin = 0;
var mRequest = null;
var barprefs = null;
var initialized = 0;

function doCheck2() { 
  var keywords = document.getElementById("searchwords2").value;
  if (keywords !== "") {
   searchPage();
   }
  else
  {
    alert('Please fill in one or more words in search text box');
  }
}

function init() {
  	barprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("purplebunny.");

    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
    var branch = preferencesService.getBranch( "extensions.purplebunny." );
  	
//	if( !branch.prefHasUserValue( "purplebunny.init" ) 
{
    branch.setCharPref( "purplebunny.bar", "status-bar" );
    branch.setCharPref( "purplebunny.nextnode", "statusbar-display" );
    branch.setBoolPref( "purplebunny.insertafter", "insertleft" );
    moveBox( branch );
}

	mRank = document.getElementById( "page-status" );

	if( branch.prefHasUserValue( "purplebunny.advanced" ) )
	{
		var advanced = branch.getIntPref( "purplebunny.advanced" );
		mState = advanced;
  		branch.setIntPref( "page-statuspref.state", mState );
  		var showgoogle = document.getElementById( "showPageStatus" );
  		showgoogle.setAttribute( "checked", mState ? "true" : "false" );
	}

	if( branch.prefHasUserValue( "purplebunny.newWin" ) )
	{
		var advanced = branch.getIntPref( "purplebunny.newWin" );
		mNewWin = advanced;
  		branch.setIntPref( "page-newwin.state", mNewWin );
  		var showgoogle2 = document.getElementById( "openNewWindow" );
  		showgoogle2.setAttribute( "checked", mNewWin ? "true" : "false" );
	}

	initialized = 1;
  	return;
}


function doClean() {
	document.getElementById('searchwords2').value = "";
	document.getElementById('queryTextbox').value = "";
}

function HandleKeyEvent(inEvent) {   //Contributed by EasySearch project developers
        if(inEvent.keyCode == 13) {
                //default 0 = this window
                var SearchWType = 0;

                //if ctrl set = 1 = in tab
                if(inEvent.ctrlKey) {
                        SearchWType = 1;
                }

                //if shift set = 2 = in new window
                if(inEvent.shiftKey) {
                        SearchWType = 2;
                }

                doMSD(SearchWType);
        }
}

function openUrl2( url )
{
	window.openDialog(url, "", "chrome,modal,resizable,close");
}

function openUrlWin( url )
{
	window.open(url, "", "resizable,close,scrollbars,menubar,toolbar,location,personalbar,status");
}

function openUrl( url )
{
  var browser = document.getElementById( "content" );
  var tab = browser.addTab( url, getReferrer( document ) );
  browser.selectedTab = tab;
}

function writePageComments(x)
{
  	var title = new String( window._content.document.title );
  	var url = new String( window._content.document.location );
  	//url = url.replace( /\?.*$/g, "?" );

  	var link = "http://www.purplebunny.com/forum.php?url=" + encodeURIComponent(url) + "&title=" + encodeURIComponent(title) + "&v=" + version;
	if (mNewWin == 1)
	{
  		openUrlWin( link );
	}
	else
	{
  		openUrl( link );
	}
}

function readPageComments(x)
{
  	var title = new String( window._content.document.title );
  	var url = new String( window._content.document.location );
  	//url = url.replace( /\?.*$/g, "?" );

  	var link = "http://www.purplebunny.com/forum.php?mode=v&url=" + encodeURIComponent(url) + "&title=" + encodeURIComponent(title) + "&v=" + version;
	if (mNewWin == 1)
	{
  		openUrlWin( link );
	}
	else
	{
  		openUrl( link );
	}
}

function readRecentComments()
{
  	var link = "http://www.purplebunny.com/bbs/index2.php";
	if (mNewWin == 1)
	{
  		openUrlWin( link );
	}
	else
	{
  		openUrl( link );
	}
}

function seeMembers()
{
  	var link = "http://www.purplebunny.com/bbs/memberlist.php";
	if (mNewWin == 1)
	{
  		openUrlWin( link );
	}
	else
	{
  		openUrl( link );
	}
}

function readSiteComments()
{
  	var url = new String( window._content.document.location );
  	//url = url.replace( /\?.*$/g, "?" );

  	var link = "http://www.purplebunny.com/site.php?url=" + encodeURIComponent(url) + "&v=" + version;
	if (mNewWin == 1)
	{
  		openUrlWin( link );
	}
	else
	{
  		openUrl( link );
	}
}

function search4Comments(  )
{
  	var url = new String( window._content.document.location );
  	var title = new String( window._content.document.title );
  	var link = "http://www.purplebunny.com/bbs/pageinfo.php?u=" + encodeURIComponent(url) + "&v=" + version + "&t=" + encodeURIComponent(title);
  	openUrl2( link );
}

function searchSite(  )
{
  	var currentHost = new String( window._content.document.location.hostname );
  	var keywords = document.getElementById("searchwords2").value;
  	var link = "http://www.purplebunny.com/bbs/search.php?mode=results&search_keywords=" + encodeURIComponent(keywords) + "&search_forum=" + encodeURIComponent(currentHost) + "&v=" + version;
	if (mNewWin == 1)
	{
  		openUrlWin( link );
	}
	else
	{
  		openUrl( link );
	}
}

function searchPage(  )
{
  	var keywords = document.getElementById("searchwords2").value;
	var link = "http://www.purplebunny.com/bbs/search.php?mode=results&search_keywords=" + encodeURIComponent(keywords) + "&v=" + version;
	if (mNewWin == 1)
	{
  		openUrlWin( link );
	}
	else
	{
  		openUrl( link );
	}
}

function showSearch(  )
{
	var link = "http://www.purplebunny.com/bbs/search.php?v=" + version;
  	openUrl( link );
}

function showAbout2()
{
	window.openDialog( "chrome://purplebunny/content/about.xul", "searchstatus-about-dialog", "centerscreen,chrome,modal" );
}

function showAbout() {
	window.openDialog("chrome://purplebunny/content/about.xul","showmore","chrome");
}

/*
function showOptions2()
{
	window.openDialog( "chrome://purplebunny/content/options/options.xul", "searchstatus-options-dialog", "centerscreen,chrome,modal" );
}
*/

function showOptions() {
    	window.openDialog("chrome://purplebunny/content/options2.xul", "pbbar-options-dialog", "centerscreen,chrome,modal");
}

window.addEventListener( "load", function() {ssLoad();}, true );
window.addEventListener( "focus", function() {ssFocus();}, true );

function ssLoad()
{

  	initStatus();
}

function ssFocus()
{
	if (initialized == 0)
	{
		init();
	}
  	initStatus();
}

function resetStatus()
{
  	var showgoogle = document.getElementById( "showPageStatus" );
  	showgoogle.setAttribute( "checked", mState ? "true" : "false" );	
  	var showgoogle2 = document.getElementById( "openNewWindow" );
  	showgoogle2.setAttribute( "checked", mNewWin ? "true" : "false" );	
  	
  	var url = new String( window._content.document.location );
  	
  	if( mState == 0 )
  	{
  		mRank.setAttribute( "hidden", "true" );
  	}
  	else 
  	{
  		mRank.setAttribute( "hidden", "false" );
  		
  		if( url == mLastURL )
  		{
//  			mRank.setAttribute( "status", mLastPR );
  		  	if( mLastPR == -1 )
  		  	{
  			}
  			else
  			{
  			}
  		}
  		else
  		{
  		  initStatus();	
  		}
  	}
}

function initStatus()
{
  	var url = new String( window._content.document.location );
	if (mRank == null)
		mRank = document.getElementById( "page-status" );
        

	var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
	var branch = preferencesService.getBranch( "extensions.purplebunny." );    	
  	if( mState == 0 )
  	{
  		mRank.setAttribute( "hidden", "true" );
		return;
  	}
  	else 
  	{
  		mRank.setAttribute( "hidden", "false" );
  		
  		if( url == mLastURL )
  		{
			mRank.setAttribute( "status", mLastPR );
			return;
		}
	}

  	var title = new String( window._content.document.title );
  	var link = "http://www.purplebunny.com/bbs/pageinfo.php?s=1&u=" + encodeURIComponent(url) + "&t=" + encodeURIComponent(title);
	//var url = new String( window._content.document.location );
	//mRank.setAttribute( "hidden", "false" );
	mRequest = new XMLHttpRequest();
	mRequest.onload = onRequestLoad;
	mRequest.open( "GET", link );
	mRequest.setRequestHeader( "User-Agent", "Mozilla/4.0 (compatible; PurpleBunny 0.5; Windows XP 5.1)" );
	mRequest.send( null );
	mLastURL = url;
}

function onRequestLoad()
{
	var temp = mRequest.responseText;
	var results = temp.split(" ");
	if (temp.length > 7)
	{
		mRank.setAttribute( "image", "chrome://purplebunny/content/img/speechgray.png" );
		mRank.setAttribute( "status", 9 );
		mLastPR = 9;
	}
	else if (results[0] > 0)
	{
		mRank.setAttribute( "image", "chrome://purplebunny/content/img/speechgreen.png" );
		mRank.setAttribute( "status", 2 );
		mLastPR = 2;
	}	
	else if (results[1] > 0)
	{
		mRank.setAttribute( "image", "chrome://purplebunny/content/img/speechyellow.png" );
		mRank.setAttribute( "status", 1 );
		mLastPR = 1;
	}	
	else 
	{
		mRank.setAttribute( "image", "chrome://purplebunny/content/img/speechpurple.png" );
		mRank.setAttribute( "status", 0 );
		mLastPR = 0;
	}	
}

  function switchWinState()
  {
	var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
	var branch = preferencesService.getBranch( "extensions.purplebunny." );    	
  	if( mNewWin == 0 )
  	{
		branch.setIntPref( "purplebunny.newWin", 1 );
  		branch.setIntPref( "page-newwin.state", 1 );
  	  	mNewWin = 1;
  	}
  	else
  	{
		branch.setIntPref( "purplebunny.newWin", 0 );
  		branch.setIntPref( "page-newwin.state", 0 );
  	  	mNewWin = 0;
  	}
  }

  function switchState()
  {
		var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
		var branch = preferencesService.getBranch( "extensions.purplebunny." );    	
  	
  	if( mState == 0 )
  	{
		branch.setIntPref( "purplebunny.advanced", 1 );
  		branch.setIntPref( "page-statuspref.state", 1 );
  	  	mState = 1;
  	  	mRank.setAttribute( "hidden", "false" );
  	}
  	else
  	{
		branch.setIntPref( "purplebunny.advanced", 0 );
  		branch.setIntPref( "page-statuspref.state", 0 );
  	  	mState = 0;
  	  	mRank.setAttribute( "hidden", "true" );
  	}
  	
  	initStatus();
  }

function moveBox( branch )
{
	var topWindow = getTopWindow();
	
	if( !branch.prefHasUserValue( "purplebunny.bar" ) || !branch.prefHasUserValue( "purplebunny.nextnode" ) || !branch.prefHasUserValue( "purplebunny.insertafter" ) )
	{
		return;
	}
	
  //check if box is in the right location
  var toolbar = topWindow.document.getElementById( branch.getCharPref( "purplebunny.bar" ) );
  var nextnode = topWindow.document.getElementById( branch.getCharPref( "purplebunny.nextnode" ) );
  var insertafter = branch.getBoolPref( "purplebunny.insertafter" );
  var ssbar	= topWindow.document.getElementById( "pbbar" );
    
  // bail if it is in the right place or the prefs are not in sync
  var neighbor = ( (insertafter) ? nextnode.nextSibling : nextnode.previousSibling );
  if( neighbor )
  {
    neighbor = neighbor.getAttribute( "id" );
  }

  if( ( ( neighbor == "pbbar" ) && ( ssbar.parentNode == toolbar ) ) || ( nextnode.parentNode != toolbar ) )
  {
    return;
  }

  //remove us from parent
  ssbar.parentNode.removeChild(ssbar);

  //place box
  if( insertafter ) 
  {
    var next_node = nextnode.nextSibling;
    if( next_node )
    {
      toolbar.insertBefore( ssbar, next_node );
    }
    else
    {
      toolbar.appendChild( ssbar );
    }
  }
  else
  {
    toolbar.insertBefore( ssbar, nextnode );
  }
}

function getTopWindow()
{
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
  var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
  if( !topWindow )
  {
    topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
  }

  return topWindow;
}
